<?php
namespace HCM\Geral\Repository\Esocial;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class S1200Repository {

    protected  $connection;

    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function getItensParaEnvioS1200($params) {
        try {
            $sql = <<<SQL
SELECT DISTINCT VM.NRPESSOA, VM.NRPESSOA as NRCHAVE,
   DECODE(CF.NRTIPOMOVIMENT,4,(CASE WHEN TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' AND CF.NROCORRECAL = 1 THEN '4' ELSE '1'END), '1') as NRTABELA,
   'I' as IDOPERACAO,
   CF.DTOCORRENCIA as DTMESCOMPETENC
FROM GPE_VINCULOM VM
JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                  AND VH.NRVINCULOM = VM.NRVINCULOM
                  AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                            WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                              AND H1.NRORG = VH.NRORG
                                              AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                              AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                          WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                            AND H1.NRORG = EH.NRORG
                                            AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                AND SUBSTR(EH.CDCNPJESTRUT,1,8) = (SELECT SUBSTR(EP.CDCNPJESTRUT,1,8) FROM ESTRUTURAH EP
                                                    WHERE EP.NRORG = :P_NRORG
                                                      AND EP.NRESTRUTURAM = :P_NRESTRUTURAM
                                                      AND EP.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                                                                WHERE H1.NRESTRUTURAM = EP.NRESTRUTURAM
                                                                                  AND H1.NRORG = EP.NRORG
                                                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC))
JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                      AND IT.NRVINCULOM = VH.NRVINCULOM
                      AND IT.NREVENTOM IN (3030,3050)
JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                      AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                      AND ((CF.NRTIPOMOVIMENT = 4 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' AND :P_NRTABELA = 4 AND CF.NROCORRECAL = 1/*OCORRENCIA 1 PARA DESCONSIDERAR 13 COMPLEMENTAR*/) OR
                           ((CF.NRTIPOMOVIMENT IN (1,2,10,19) OR (CF.NRTIPOMOVIMENT = 4 AND (TO_CHAR(CF.DTOCORRENCIA,'MM') <> '12' OR (TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'AND CF.NROCORRECAL <> 1)))) AND :P_NRTABELA = 1) OR 
                           (:P_NRTABELA IS NULL AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)))
                      AND CF.NRTPMODALIDCAL = 1
                      AND CF.DTOCORRENCIA = :P_DTMESCOMPETENC
LEFT JOIN ESO_PARAMETRO ESOPARAMS ON ESOPARAMS.NRESTRUTURAM = EH.NRESTRUTURAM
                           AND ESOPARAMS.NRORG = EH.NRORG 
WHERE VM.NRORG = :P_NRORG
AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
AND (VM.NRTIPOVINCULOM = 1 OR (VM.NRTIPOVINCULOM IN (2,10) AND (CF.NRTIPOMOVIMENT = 1 OR (CF.NRTIPOMOVIMENT = 4 AND IT.VREVENTOFOLHA > 0)))
    OR VM.NRTIPOVINCULOM = 3 AND (CF.NRTIPOMOVIMENT IN (1,19) OR (CF.NRTIPOMOVIMENT = 4 AND IT.VREVENTOFOLHA > 0)))
AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC > LAST_DAY(:P_DTMESCOMPETENC)) AND IT.NREVENTOM = 3030) OR
    (VM.DTRESCISAOVINC < :P_DTMESCOMPETENC AND IT.NREVENTOM = 3050))
AND EXISTS (
            SELECT 1
              FROM FPA_ITECALCFOLHA ITC
              /*Rubrica*/
              JOIN FPA_EVENTOM EMC ON (EMC.NRORG = ITC.NRORG OR EMC.NRORG = 0)
                                 AND EMC.NREVENTOM = ITC.NREVENTOM
                                 --AND EMC.IDTIPOEVENTO IN ('PROVENTO','DESCONTO','ENCARGO')
              JOIN FPA_EVENTOH EHC ON EHC.NRORG = EMC.NRORG
                                 AND EHC.NREVENTOM = EMC.NREVENTOM
                                 AND EHC.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                            WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                              AND EHH.NREVENTOM = EHC.NREVENTOM
                                                              AND EHH.NRORG = EHC.NRORG)
              /*Natureza da Rubrica*/
              JOIN NATUREZARUBRICA NRC ON NRC.NRNATURUBR = EHC.NRNATURUBR
              /*CP NOVO*/
              LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                           FROM FPA_INCIDEVENTO IE
                           JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                           JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                          WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                            AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                  FROM FPA_GRPITEM 
                                                 WHERE NRGRPINCIDE = 46) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                          GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                         ) CP ON CP.NREVENTOM = EMC.NREVENTOM
                             AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
              /*IRRF NOVO*/
              LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                           FROM FPA_INCIDEVENTO IE
                           JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                           JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                          WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                            AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                  FROM FPA_GRPITEM 
                                                 WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                          GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                         ) IRRF ON IRRF.NREVENTOM = EMC.NREVENTOM
                               AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
             WHERE ITC.NRORG = IT.NRORG
               AND ITC.NRVINCULOM = IT.NRVINCULOM
               AND ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
               AND ITC.VREVENTOFOLHA > 0
               AND ((ITC.IDEVENDEMONCALC = 'N' AND EHC.IDEVENTODEMONST = 'N') OR (EHC.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
               AND (CP.CDESOCIAL NOT IN (23, 24, 61) OR CP.CDESOCIAL IS NULL) /*{codIncCP} em S-1010 seja igual a [23, 24, 61]*/
               AND (IRRF.CDESOCIAL NOT IN (31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83) OR IRRF.CDESOCIAL IS NULL) /*{codIncIRRF} em S-1010 seja igual a [31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83]*/)
AND ((IT.NREVENTOM = 3050 AND ESOPARAMS.IDAPROVACALCRESC = 'S' AND EXISTS(SELECT 1
                                                                           FROM FPA_ITECALCFOLHA ITFEC 
                                                                          WHERE ITFEC.NRORG = VH.NRORG
                                                                            AND ITFEC.NRVINCULOM = VH.NRVINCULOM
                                                                            AND ITFEC.NREVENTOM = 3035
                                                                            AND ITFEC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA)) 
    OR NVL(ESOPARAMS.IDAPROVACALCRESC, 'N') = 'N'
    OR IT.NREVENTOM <> 3050)
AND (VM.NRPESSOA = :P_NRPESSOA OR :P_NRPESSOA IS NULL)
ORDER BY 1,2
SQL;
            $params = array(
                "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
                "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
                "P_NRESTRUTURAM" => isset($params['NRESTRUTURAM']) ? $params['NRESTRUTURAM'] : null,
                "P_NRPESSOA" => isset($params['NRPESSOA']) ? $params['NRPESSOA'] : null,
                "P_NRTABELA" => isset($params['NRTIPOMOVIMENT']) ? $params['NRTIPOMOVIMENT'] : null
            );
            return $this->connection->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getDadosS1200($params) {
        try {
            $dataHistorico = \HCM\Util\DateUtil::getDataDeString($params['DTMESCOMPETENC'], \HCM\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA, true)->format("d/m/Y");
            
            $dados = $this->getDadosPrincipais($params['NRESTRUTURAM'], $params['NRTPAMBIENTE'], $params['NRCHAVE'], $params['NRTABELA'], $dataHistorico);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function getDadosPrincipais($nrestruturam, $nrtpambiente, $nrchave, $nrtabela, $dtocorrencia) {
        $sql = <<<SQL
/*getDadosS1200*/
SELECT DISTINCT VM.NRPESSOA CHAVE,
       /*ideEvento*/
       CASE WHEN CF.NRTIPOMOVIMENT = 4 AND CF.NROCORRECAL = 1 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' THEN '2' ELSE '1' END as indApuracao,
       TO_CHAR(CF.DTOCORRENCIA, CASE WHEN CF.NRTIPOMOVIMENT = 4 AND CF.NROCORRECAL = 1 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' THEN 'YYYY' ELSE 'YYYY-MM' END) as perApur,
       /*ideEmpregador*/
       DECODE(PAR.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') TPINSC,
       CASE WHEN PAR.CDTIPOINSCRICAO = 'CPF' OR EMH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PAR.NRINSCRICAOPARC ELSE SUBSTR(PAR.NRINSCRICAOPARC,1,8) END NRINSC,    
       /*ideTrabalhador*/
       REPLACE(REPLACE(PH.NRCPFPESSOA,'.'),'-') AS cpfTrab,
       /*infoMV*/
       DECODE(OV.VRREMUNOUTREMPR, NULL, NULL, DECODE(VH.IDMULTVINC, 'PRIMARIO', '1', '3')) indMV,
       /*remunOutrEmpr getDadosS1200remunOutrEmpr*/
       /*infoComplem*/
       /*CASE WHEN ENV.NRENVIO IS NULL /*OR VM.NRTIPOVINCULOM IN (2,3,10)/ THEN PH.NMPESSOA ELSE '' END*/ '' nmTrab,
       /*CASE WHEN ENV.NRENVIO IS NULL /*OR VM.NRTIPOVINCULOM IN (2,3,10)/ THEN TO_CHAR(PH.DTNASCPESSOA, 'YYYY-MM-DD') ELSE NULL END*/ '' dtNascto,
       /*sucessaoVinc*/
       null tpInsc_sucessaoVinc,
       null nrInsc_sucessaoVinc,
       null matricAnt,
       null dtAdm,
       null observacao,
       /*procJudTrab getDadosS1200procJudTrab*/
       /*infoInterm getDadosS2299infoInterm*/
       /*dmDev getDadosS1200dmDev*/
       /*ideEstabLot getDadosS1200ideEstabLot*/
       /*detVerbas getDadosS1200detVerbas*/
       /*infoPerAnt getDadosS1200infoPerAnt*/
       VM.NRORG, VM.NRPESSOA, PE.NRPARCNEGOCIO, VH.NRESTRUTLEGAL, PAR.NRINSCRICAOPARC, :P_NRTABELA AS NRTABELA, :P_DTOCORRENCIA AS DTOCORRENCIA, OV.VRREMUNOUTREMPR, CE.CDESOCIAL AS CDCATEGTRAB,
       DECODE(:P_NRTPAMBIENTE, 1, DECODE(EMH.IDOPTSIMPLES, 'S', :P_INIVALIDADEAMBNS, :P_INIVALIDADEAMBP), 2, :P_INIVALIDADEAMBPR) INIVALIDADEAMB
  FROM GPE_VINCULOM VM
  /*Dados do Empregado - Vínculo*/
  JOIN GPE_VINCULOH VH
    ON VH.NRVINCULOM = VM.NRVINCULOM
   AND VH.NRORG      = VM.NRORG
   AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                             WHERE GPE_VINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                               AND GPE_VINCULOH.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                               AND GPE_VINCULOH.NRVINCULOM = VM.NRVINCULOM
                               AND GPE_VINCULOH.NRORG = VM.NRORG)
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Dados do Empregado - Pessoa*/                               
  JOIN GPE_PESSOA PE
    ON PE.NRPESSOA = VM.NRPESSOA
   AND PE.NRORG    = VM.NRORG
  JOIN GPE_PESSOAH PH
    ON PH.NRPESSOA = PE.NRPESSOA
   AND PH.NRORG    = PE.NRORG
   AND PH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                             WHERE GPE_PESSOAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                               AND GPE_PESSOAH.NRPESSOA = PE.NRPESSOA
                               AND GPE_PESSOAH.NRORG = PE.NRORG)
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Calculo*/
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
                          AND CF.DTOCORRENCIA = :P_DTOCORRENCIA
                          AND ((CF.NRTIPOMOVIMENT = 4 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' AND :P_NRTABELA = 4 AND CF.NROCORRECAL = 1/*OCORRENCIA 1 PARA DESCONSIDERAR 13 COMPLEMENTAR*/) OR
                               ((CF.NRTIPOMOVIMENT IN (1,2,10,19) OR (CF.NRTIPOMOVIMENT = 4 AND (TO_CHAR(CF.DTOCORRENCIA,'MM') <> '12' OR (TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'AND CF.NROCORRECAL <> 1)))) AND :P_NRTABELA = 1))
  /*Empregador*/
  LEFT JOIN ESTRUTURAH EMH ON EMH.NRORG = :P_NRORG
                     AND EMH.NRESTRUTURAM = :P_NRESTRUTURAM
                     AND EMH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                               WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                 AND ESTRUTURAH.NRESTRUTURAM = EMH.NRESTRUTURAM
                                                 AND ESTRUTURAH.NRORG = EMH.NRORG)
  JOIN PARCNEGOCIO PAR ON PAR.NRPARCNEGOCIO = EMH.NRPARCNEGOCIO
                      AND PAR.NRORG = EMH.NRORG
  /*Remuneração Outra Empresa*/
  LEFT JOIN (SELECT OV.NRORG, OV.NRVINCULOM, OV.NRPESSOA, EH.CDCNPJESTRUT, SUM(ITC.VREVENTOFOLHA) VRREMUNOUTREMPR
               FROM GPE_VINCULOM OV
               JOIN GPE_VINCULOH OVH ON OVH.NRVINCULOM = OV.NRVINCULOM
                                    AND OVH.NRORG      = OV.NRORG
                                    AND OVH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                              WHERE GPE_VINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                AND GPE_VINCULOH.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                                AND GPE_VINCULOH.NRVINCULOM = OVH.NRVINCULOM
                                                                AND GPE_VINCULOH.NRORG = OVH.NRORG)
               LEFT JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = OVH.NRESTRUTLEGAL
                                 AND EH.NRORG = OVH.NRORG
                                 AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                           WHERE ESTRUTURAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                             AND ESTRUTURAH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                             AND ESTRUTURAH.NRORG = EH.NRORG)
               JOIN FPA_ITECALCFOLHA ITC ON ITC.NRORG = OV.NRORG
                                        AND ITC.NRVINCULOM = OV.NRVINCULOM
                                        AND ITC.NREVENTOM = 3030
               JOIN FPA_CALCULOFOLHA CF ON CF.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                       AND CF.NRORG = ITC.NRORG
                                       AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                                       AND CF.NRTPMODALIDCAL = 1
                                       AND CF.DTOCORRENCIA = :P_DTOCORRENCIA
                                       AND ((CF.NRTIPOMOVIMENT = 4 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' AND :P_NRTABELA = 4 AND CF.NROCORRECAL = 1/*OCORRENCIA 1 PARA DESCONSIDERAR 13 COMPLEMENTAR*/) OR
                                            ((CF.NRTIPOMOVIMENT IN (1,2,10,19) OR (CF.NRTIPOMOVIMENT = 4 AND (TO_CHAR(CF.DTOCORRENCIA,'MM') <> '12' OR (TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'AND CF.NROCORRECAL <> 1)))) AND :P_NRTABELA = 1))
              WHERE OV.NRORG = :P_NRORG
                AND OV.NRVINCULOM = :P_NRCHAVE
              GROUP BY OV.NRORG, OV.NRVINCULOM, OV.NRPESSOA, EH.CDCNPJESTRUT) OV ON OV.NRORG = VM.NRORG
                                                                                AND OV.NRPESSOA = VM.NRPESSOA
                                                                                AND OV.NRVINCULOM <> VM.NRVINCULOM
                                                                                AND SUBSTR(OV.CDCNPJESTRUT,1,8) <> SUBSTR(EMH.CDCNPJESTRUT,1,8)
  /*Envios de admissão*/
  /*LEFT JOIN ESO_ENVIOCADASTROS ENV ON ENV.NRORG = VM.NRORG
                                  AND ENV.NRESTRUTURAM = VH.NRESTRUTLEGAL
                                  AND ENV.NRCHAVE = VM.NRVINCULOM
                                  AND ENV.NRTPAMBIENTE = P_NRTPAMBIENTE
                                  AND ENV.IDATIVO = 'S'
                                  AND (ENV.IDSTATUS = 'C' OR ENV.IDSTATUS = 'A')
                                  AND ENV.NRENVIOEXCL IS NULL
                                  AND ENV.NREVENTO IN (SELECT EVE.NREVENTO FROM ESO_EVENTO EVE
                                                        WHERE EVE.NREVENTO = ENV.NREVENTO
                                                          AND EVE.NMEVENTO = DECODE(VM.NRTIPOVINCULOM,1,'S-2200','S-2300'))*/
 WHERE VM.NRORG = :P_NRORG
   AND VM.NRPESSOA = :P_NRCHAVE
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(PAR.NRINSCRICAOPARC,1,8)
SQL;
        $params = array(
            "P_NRORG" => $this->hcmParameters->getNrorgTrabalho(),
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTPAMBIENTE" => $nrtpambiente,
            "P_INIVALIDADEAMBPR" => $this->hcmParameters->getEsoIniValidPeriodProdRest(),
            "P_INIVALIDADEAMBP" => $this->hcmParameters->getEsoIniValidPeriodProducao(),
            "P_INIVALIDADEAMBNS" => $this->hcmParameters->getEsoIniValidPeriodNacioSimples(),
            "P_NRESTRUTURAM" => $nrestruturam,
            "P_NRCHAVE" => $nrchave,
            "P_NRTABELA" => $nrtabela,
            "P_DTOCORRENCIA" => $dtocorrencia,
            "P_NRTPAMBIENTE" => $nrtpambiente,
        );
        return $this->connection->fetchAssoc($sql, $params);
    }

    public function getDadosS1200remunOutrEmpr($params) {
        try {
            $dados = $this->getDadosSRemunOutrEmpr($params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['NRTABELA'], $params['DTOCORRENCIA']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosSRemunOutrEmpr($nrorg, $nrpessoa, $nrinscricaoparc, $nrtabela, $dtocorrencia) {
        $sql = <<<SQL
/*getDadosS1200remunOutrEmpr*/
SELECT DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2','') AS tpInsc_remunOutrEmpr,
       CASE WHEN PN.CDTIPOINSCRICAO = 'CPF' OR EH.CDNATUJURI IN ('1015','1040','1074','1163') THEN PN.NRINSCRICAOPARC ELSE SUBSTR(PN.NRINSCRICAOPARC,1,8) END nrInsc_remunOutrEmpr,
       CE.CDESOCIAL AS codCateg,
       ITC.VREVENTOFOLHA AS vlrRemunOE
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.NRORG = VM.NRORG
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                 FROM GPE_VINCULOH
                                                WHERE GPE_VINCULOH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND GPE_VINCULOH.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND GPE_VINCULOH.NRVINCULOM = VH.NRVINCULOM
                                                  AND GPE_VINCULOH.NRORG = VH.NRORG)
  /*Outro Empregador*/
  JOIN ESTRUTURAM EM ON EM.NRORG = VM.NRORG
                    AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
  LEFT JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM    = EM.NRESTRUTURAM
                    AND EH.NRORG          = EM.NRORG
                    AND EH.DTMESCOMPETENC =
                      (SELECT MAX(EHH.DTMESCOMPETENC)
                      FROM ESTRUTURAH EHH
                      WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                      AND EHH.NRESTRUTURAM      = EH.NRESTRUTURAM
                      AND EHH.NRORG             = EH.NRORG)
  JOIN PARCNEGOCIO PN ON PN.NRORG             = EM.NRORG
                     AND PN.NRPARCNEGOCIO    = EM.NRPARCNEGOCIO
  /*Categoria Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Remuneração Outra Empresa*/
  JOIN (SELECT ITC.NRORG, ITC.NRVINCULOM, SUM(ITC.VREVENTOFOLHA) VREVENTOFOLHA
          FROM FPA_ITECALCFOLHA ITC
          JOIN FPA_CALCULOFOLHA CF ON CF.NRCALCULOFOLHA = ITC.NRCALCULOFOLHA
                                  AND CF.NRORG = ITC.NRORG
                                  AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                                  AND CF.NRTPMODALIDCAL = 1
                                  AND CF.DTOCORRENCIA = :P_DTOCORRENCIA
         WHERE ITC.NRORG = :P_NRORG
           AND ITC.NREVENTOM = 3030
         GROUP BY ITC.NRORG, ITC.NRVINCULOM) ITC ON ITC.NRORG = VM.NRORG
                                                AND ITC.NRVINCULOM = VM.NRVINCULOM
 WHERE VM.NRPESSOA = :P_NRPESSOA
   AND VM.NRORG = :P_NRORG
   AND SUBSTR(PN.NRINSCRICAOPARC,1,8) != SUBSTR(:P_NRINSCRICAOPARC,1,8)
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRPESSOA" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_NRTABELA" => $nrtabela,
            "P_DTOCORRENCIA" => $dtocorrencia,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS1200procJudTrab($params) {
        try {
            $dados = $this->getDadosProcJudTrab($params['NRORG'], $params['NRPESSOA']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosProcJudTrab($nrorg, $nrpessoa) {
        $sql = <<<SQL
/*getDadosS1200procJudTrab*/
SELECT * FROM DUAL WHERE 1=2
SQL;
        $params = array(
            
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
    public function getDadosS1200infoInterm($params) {
        if ($params['CDCATEGTRAB'] == '111') {
            $dados = $this->getDadosInfoInterm($params['NRORG'], $params['NRPESSOA'], $params['CDCATEGTRAB'], $params['DTMESCOMPETENC']);
            return $dados;
        } else {
            return array();
        }
    }
    
    public function getDadosInfoInterm($nrorg, $nrpessoa, $cdcategtrab, $dtmescompetenc) {
        $sql = <<<SQL
/*getDadosS1200infoInterm*/
--SELECT TO_NUMBER(TO_CHAR(DT.DTDATA,'DD')) AS DIA
SELECT COUNT(DT.DTDATA) AS DIA
  FROM GPE_CONVOCACAO CO
  JOIN DATA DT ON DT.DTDATA BETWEEN CO.DTINICONVOCACAO AND CO.DTFIMCONVOCACAO
  JOIN GPE_VINCULOM VM ON VM.NRORG = CO.NRORG
                      AND VM.NRVINCULOM = CO.NRVINCULOM
                      AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
                      AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC)
 WHERE CO.NRORG = :P_NRORG
   AND VM.NRPESSOA = :P_NRPESSOA
   AND :P_CDCATEGTRAB = '111'
   AND DT.DTDATA BETWEEN :P_DTMESCOMPETENC AND LAST_DAY(:P_DTMESCOMPETENC)
 ORDER BY 1
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_NRPESSOA" => $nrpessoa,
            "P_CDCATEGTRAB" => $cdcategtrab,
            "P_DTMESCOMPETENC" => $dtmescompetenc,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS1200dmDev($params) {
        try {
            $dados = $this->getDadosDmDev($params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['NRTABELA'], $params['DTOCORRENCIA']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosDmDev($nrorg, $nrpessoa, $nrinscricaoparc, $nrtabela, $dtocorrencia) {
        $sql = <<<SQL
/*getDadosS1200dmDev*/
SELECT IT.NRCALCULOFOLHA AS ideDmDev,
       CE.CDESOCIAL AS codCateg,
       SUM(CASE WHEN (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC) THEN 1 ELSE 0 END) AS infoPerApur,
       0 AS infoPerAnt,
       /*infoComplCont*/
       '' codCBO,
       '' natAtividade,
       '' qtdDiasTrab,
       VM.NRORG, VM.NRPESSOA, :P_NRINSCRICAOPARC NRINSCRICAOPARC, IT.NRCALCULOFOLHA, CE.CDESOCIAL CDCATEGTRAB
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = VH.NRORG
                    AND EH.NRESTRUTURAM = VH.NRESTRUTLEGAL
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
                          AND CF.NRTIPOMOVIMENT IN (1,2,4,10,19)
                          AND CF.NRTPMODALIDCAL = 1
                          AND CF.DTOCORRENCIA = :P_DTOCORRENCIA
                          AND ((CF.NRTIPOMOVIMENT = 4 AND TO_CHAR(CF.DTOCORRENCIA,'MM') = '12' AND :P_NRTABELA = 4 AND CF.NROCORRECAL = 1/*OCORRENCIA 1 PARA DESCONSIDERAR 13 COMPLEMENTAR*/) OR
                               ((CF.NRTIPOMOVIMENT IN (1,2,10,19) OR (CF.NRTIPOMOVIMENT = 4 AND (TO_CHAR(CF.DTOCORRENCIA,'MM') <> '12' OR (TO_CHAR(CF.DTOCORRENCIA,'MM') = '12'AND CF.NROCORRECAL <> 1)))) AND :P_NRTABELA = 1))
  /*Categoria Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  LEFT JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC) AND IT.NREVENTOM = 3030) OR
        (VM.DTRESCISAOVINC < :P_DTMESCOMPETENC AND IT.NREVENTOM = 3050))
   AND VM.NRPESSOA = :P_NRCHAVE
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND (VM.NRTIPOVINCULOM = 1 OR (VM.NRTIPOVINCULOM IN (2,10) AND (CF.NRTIPOMOVIMENT = 1 OR (CF.NRTIPOMOVIMENT = 4 AND IT.VREVENTOFOLHA > 0)))
        OR VM.NRTIPOVINCULOM = 3 AND (CF.NRTIPOMOVIMENT IN (1,19) OR (CF.NRTIPOMOVIMENT = 4 AND IT.VREVENTOFOLHA > 0)))
   AND EXISTS (/*getDadosS1200itensRemun*/
                SELECT 1
                  FROM FPA_ITECALCFOLHA ITC
                  /*Rubrica*/
                  JOIN FPA_EVENTOM EMC ON (EMC.NRORG = ITC.NRORG OR EMC.NRORG = 0)
                                     AND EMC.NREVENTOM = ITC.NREVENTOM
                                     --AND EMC.IDTIPOEVENTO IN ('PROVENTO','DESCONTO','ENCARGO')
                  JOIN FPA_EVENTOH EHC ON EHC.NRORG = EMC.NRORG
                                     AND EHC.NREVENTOM = EMC.NREVENTOM
                                     AND EHC.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                                WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                  AND EHH.NREVENTOM = EHC.NREVENTOM
                                                                  AND EHH.NRORG = EHC.NRORG)
                  /*Natureza da Rubrica*/
                  JOIN NATUREZARUBRICA NRC ON NRC.NRNATURUBR = EHC.NRNATURUBR
                  /*CP NOVO*/
                  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                               FROM FPA_INCIDEVENTO IE
                               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                               JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                      FROM FPA_GRPITEM 
                                                     WHERE NRGRPINCIDE = 46) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                             ) CP ON CP.NREVENTOM = EHC.NREVENTOM
                                 AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
                  /*IRRF NOVO*/
                  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
                               FROM FPA_INCIDEVENTO IE
                               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                               JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                      FROM FPA_GRPITEM 
                                                     WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
                             ) IRRF ON IRRF.NREVENTOM = EHC.NREVENTOM
                                   AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
                 WHERE ITC.NRORG = IT.NRORG
                   AND ITC.NRVINCULOM = IT.NRVINCULOM
                   AND ITC.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
                   AND ITC.VREVENTOFOLHA > 0
                   AND ((ITC.IDEVENDEMONCALC = 'N' AND EHC.IDEVENTODEMONST = 'N') OR (EHC.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
                   AND (CP.CDESOCIAL NOT IN (23, 24, 61) OR CP.CDESOCIAL IS NULL) /*{codIncCP} em S-1010 seja igual a [23, 24, 61]*/
                   AND (IRRF.CDESOCIAL NOT IN (31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83) OR IRRF.CDESOCIAL IS NULL) /*{codIncIRRF} em S-1010 seja igual a [31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83]*/)
 GROUP BY IT.NRCALCULOFOLHA, CE.CDESOCIAL, VM.NRORG, VM.NRPESSOA, :P_NRINSCRICAOPARC, IT.NRCALCULOFOLHA, CE.CDESOCIAL
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRCHAVE" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_NRTABELA" => $nrtabela,
            "P_DTOCORRENCIA" => $dtocorrencia,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS1200ideEstabLot($params) {
        try {
            $dados = $this->getDadosIdeEstabLot($params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['NRCALCULOFOLHA'], $params['CDCATEGTRAB'], $params['INFOPERAPUR'], $params['INFOPERANT']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosIdeEstabLot($nrorg, $nrpessoa, $nrinscricaoparc, $nrcalculofolha, $cdcategtrab, $infoPerApur, $infoPerAnt) {
        $sql = <<<SQL
/*getDadosS1200ideEstabLot*/
SELECT DISTINCT
       CASE
            WHEN (EH.CDCEIESTRUT IS NOT NULL AND EH.CDCAEPFESTRUT IS NULL) THEN '4'
            WHEN (EH.CDCEIESTRUT IS NULL AND EH.CDCAEPFESTRUT IS NOT NULL) THEN '3' 
            WHEN (EH.CDCEIESTRUT IS NOT NULL AND EH.CDCAEPFESTRUT IS NOT NULL) THEN '3'
            ELSE DECODE(PN.CDTIPOINSCRICAO,'CNPJ','1','CPF','2')
       END tpInsc,
       NVL(NVL(EH.CDCAEPFESTRUT,EH.CDCEIESTRUT),PN.NRINSCRICAOPARC) nrInsc,
       DECODE(VM.NRTIPOVINCULOM, 2, EM.NRESTRUTURAM, 3, EM.NRESTRUTURAM, NVL(EMSUP.NRESTRUTURAM, EM.NRESTRUTURAM)) AS codLotacao,
       NULL qtdDiasAv,
       /*remunPerApur getDadosS1200remunPerApur*/
       /*remunPerAnt getDadosS1200remunPerAnt*/
       VM.NRORG, VM.NRPESSOA, PN.NRINSCRICAOPARC, IT.NRCALCULOFOLHA NRCALCULOFOLHA, :P_CDCATEGTRAB CDCATEGTRAB
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Pagamentos*/
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM IN (3030,3050)
  /*Estabelecimento/Lotacao*/
  JOIN ESTRUTURAM EM ON EM.NRORG = VH.NRORG
                    AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN PARCNEGOCIO PN ON PN.NRORG = EM.NRORG
                     AND PN.NRPARCNEGOCIO = EM.NRPARCNEGOCIO
  /*Estabelecimento/Lotacao - Tomador superior da estrutura gerencial*/
  LEFT JOIN TIPOHIERARQORG TH ON (TH.NRORG = EM.NRORG OR TH.NRORG = 0)
                             AND TH.NRTIPOESTRUTREL = :P_NRTIPOESTRUTGEREN
                             AND TH.NRTIPOESTRUTSUP = NVL(:P_NRTIPOESTRUTOMADOR, 7)
  LEFT JOIN HIERARQUIAORG HO ON HO.NRORG = EM.NRORG
                            AND HO.NRTIPOHIERARQORG = TH.NRTIPOHIERARQORG
                            AND HO.NRESTRUTURAMREL = VH.NRESTRUTGEREN
                            AND HO.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA)
                                                      FROM HIERARQUIAORG HI
                                                     WHERE HI.NRORG = HO.NRORG
                                                       AND HI.NRESTRUTURAMREL = HO.NRESTRUTURAMREL
                                                       AND NRTIPOHIERARQORG = HO.NRTIPOHIERARQORG
                                                       AND EM.DTINIVIGENCIA <= :P_DTMESCOMPETENC)
                            AND (HO.DTFIMVIGENCIA >= LAST_DAY(:P_DTMESCOMPETENC) OR HO.DTFIMVIGENCIA IS NULL)
  LEFT JOIN ESTRUTURAM EMSUP ON EMSUP.NRESTRUTURAM = HO.NRESTRUTURAMSUP
                            AND EMSUP.NRORG = HO.NRORG
  /*Categoria Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (((VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC) AND IT.NREVENTOM = 3030 AND :P_INFOPERAPUR >= 1) OR
        (VM.DTRESCISAOVINC < :P_DTMESCOMPETENC AND IT.NREVENTOM = 3050 AND :P_INFOPERANT >= 1))
   AND VM.NRPESSOA = :P_NRPESSOA
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND IT.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
   AND CE.CDESOCIAL = :P_CDCATEGTRAB
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTIPOESTRUTGEREN" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
            "P_NRTIPOESTRUTOMADOR" => $this->hcmParameters->getTipoEstruturaTomadorOrg(),
            "P_NRPESSOA" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_NRCALCULOFOLHA" => $nrcalculofolha,
            "P_CDCATEGTRAB" => $cdcategtrab,
            "P_INFOPERAPUR" => $infoPerApur,
            "P_INFOPERANT" => $infoPerAnt,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS1200remunPerApur($params) {
        try {
            $dados = $this->getDadosRemunPerApur($params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['NRCALCULOFOLHA'], $params['CDCATEGTRAB']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosRemunPerApur($nrorg, $nrpessoa, $nrinscricaoparc, $nrcalculofolha, $cdcategtrab) {
        $sql = <<<SQL
/*getDadosS1200remunPerApur*/
SELECT DISTINCT
       CASE WHEN CE.CDESOCIAL IN ('101','102','103','104','105','106','111','301','302','303','305','306','307','308','309') THEN NVL(VH.CDMATRICULAESOCIAL, VM.NRVINCULOM) ELSE NULL END AS matricula,
       DECODE(NVL(CTSUP.CDESOCIAL,CT.CDESOCIAL),'01','1','02','2','03','3','') AS indSimples,
       /*itensRemun getDadosS1200itensRemun*/
       CASE
         WHEN CE.CDESOCIAL IN ('101','102','103','104','105','106','111','201','202','301','302','303','305','306','307','308','309','731','734','738')
         THEN DECODE(AN.CDESOCIALNOCIVO,NULL,1,AN.CDESOCIALNOCIVO)
         ELSE NULL
       END AS grauExp,
       VM.NRORG, VM.NRVINCULOM, IT.NRCALCULOFOLHA,
       (SELECT DECODE(NVL(SUM(IC.VREVENTOFOLHA),0),0,0,1) IDDETOPER
          FROM FPA_ITECALCFOLHA IC
          JOIN FPA_EVENTOH EVH ON (EVH.NRORG = IC.NRORG OR EVH.NRORG = 0)
                              AND EVH.NREVENTOM = IC.NREVENTOM
                              AND EVH.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                          WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                            AND EHH.NREVENTOM = EVH.NREVENTOM
                                                            AND EHH.NRORG = EVH.NRORG)
          JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EVH.NRNATURUBR
         WHERE IC.NRORG = IT.NRORG
           AND IC.NRVINCULOM = IT.NRVINCULOM
           AND IC.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
           AND NR.CDESOCIAL = '9219') IDDETOPER /*existe desconto de assistencia odontologica*/
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Pagamentos*/
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
                          AND IT.NREVENTOM = 3030
  /*Estabelecimento/Lotacao*/
  JOIN ESTRUTURAM EM ON EM.NRORG = VH.NRORG
                    AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN PARCNEGOCIO PN ON PN.NRORG = EM.NRORG
                     AND PN.NRPARCNEGOCIO = EM.NRPARCNEGOCIO
  LEFT JOIN CLASSTRIBUT CT ON CT.NRCLASSTRIBUT = EH.NRCLASSTRIBUT
  /*Estabelecimento/Lotacao - Tomador superior da estrutura gerencial*/
  LEFT JOIN TIPOHIERARQORG TH ON (TH.NRORG = EM.NRORG OR TH.NRORG = 0)
                             AND TH.NRTIPOESTRUTREL = :P_NRTIPOESTRUTGEREN
                             AND TH.NRTIPOESTRUTSUP = NVL(:P_NRTIPOESTRUTOMADOR, 7)
  LEFT JOIN HIERARQUIAORG HO ON HO.NRORG = EM.NRORG
                            AND HO.NRTIPOHIERARQORG = TH.NRTIPOHIERARQORG
                            AND HO.NRESTRUTURAMREL = VH.NRESTRUTGEREN
                            AND HO.DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA)
                                                      FROM HIERARQUIAORG HI
                                                     WHERE HI.NRORG = HO.NRORG
                                                       AND HI.NRESTRUTURAMREL = HO.NRESTRUTURAMREL
                                                       AND NRTIPOHIERARQORG = HO.NRTIPOHIERARQORG
                                                       AND EM.DTINIVIGENCIA <= :P_DTMESCOMPETENC)
                            AND (HO.DTFIMVIGENCIA >= LAST_DAY(:P_DTMESCOMPETENC) OR HO.DTFIMVIGENCIA IS NULL)
  LEFT JOIN ESTRUTURAM EMSUP ON EMSUP.NRESTRUTURAM = HO.NRESTRUTURAMSUP
                            AND EMSUP.NRORG = HO.NRORG
  LEFT JOIN ESTRUTURAH EHSUP ON EHSUP.NRESTRUTURAM = EMSUP.NRESTRUTURAM
                            AND EHSUP.NRORG = EMSUP.NRORG
                            AND EHSUP.DTMESCOMPETENC = (SELECT MAX(EHHSUP.DTMESCOMPETENC) FROM ESTRUTURAH EHHSUP
                                                         WHERE EHHSUP.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                           AND EHHSUP.NRESTRUTURAM = EH.NRESTRUTURAM
                                                           AND EHHSUP.NRORG = EH.NRORG)
  LEFT JOIN CLASSTRIBUT CTSUP ON CTSUP.NRCLASSTRIBUT = EHSUP.NRCLASSTRIBUT
  /*Categoria Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Grau de Exposição de Agente Nocivo*/
  LEFT JOIN GPE_AGENTENOCIVO AN ON AN.NRAGENTENOCIVO = VH.NRAGENTENOCIVO
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND (VM.DTRESCISAOVINC IS NULL OR VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC)
   AND VM.NRPESSOA = :P_NRCHAVE
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND CE.CDESOCIAL = :P_CDCATEGTRAB
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRTIPOESTRUTGEREN" => $this->hcmParameters->getTipoEstruturaGerencialOrg(),
            "P_NRTIPOESTRUTOMADOR" => $this->hcmParameters->getTipoEstruturaTomadorOrg(),
            "P_NRCHAVE" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_NRCALCULOFOLHA" => $nrcalculofolha,
            "P_CDCATEGTRAB" => $cdcategtrab,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS1200itensRemun($params) {
        try {
            $dados = $this->getDadosItensRemun($params['NRORG'], $params['NRVINCULOM'], $params['NRCALCULOFOLHA']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosItensRemun($nrorg, $nrvinculom, $nrcalculofolha) {
        $sql = <<<SQL
/*getDadosS1200itensRemun*/
SELECT IT.NREVENTOM AS codRubr,
       CASE WHEN TO_NUMBER(TO_CHAR(CF.DTOCORRENCIA,'MM')) BETWEEN 1 AND 11 AND CF.NRTIPOMOVIMENT = 4 THEN 22 ELSE CF.NRTIPOMOVIMENT END AS ideTabrubr,
       ROUND(DECODE(IT.VRREFFOLHA, 0, '', IT.VRREFFOLHA),2) AS qtdRubr,
       ROUND(EH.VRPERCENTUALEVENTO,2) AS fatorRubr,
       ROUND(IT.VREVENTOFOLHA,2) AS vrRubr,
       0 AS indApurIR
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Pagamentos*/
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
  JOIN FPA_CALCULOFOLHA CF ON CF.NRORG = IT.NRORG
                          AND CF.NRCALCULOFOLHA = IT.NRCALCULOFOLHA
  /*Rubrica*/
  JOIN FPA_EVENTOM EM ON (EM.NRORG = IT.NRORG OR EM.NRORG = 0)
                     AND EM.NREVENTOM = IT.NREVENTOM
                     --AND EM.IDTIPOEVENTO IN ('PROVENTO','DESCONTO','ENCARGO')
  JOIN FPA_EVENTOH EH ON EH.NRORG = EM.NRORG
                     AND EH.NREVENTOM = EM.NREVENTOM
                     AND EH.DTMESCOMPETENC  = (SELECT MAX(EHH.DTMESCOMPETENC) FROM FPA_EVENTOH EHH
                                                WHERE EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                  AND EHH.NREVENTOM = EH.NREVENTOM
                                                  AND EHH.NRORG = EH.NRORG)
  /*Natureza da Rubrica*/
  JOIN NATUREZARUBRICA NR ON NR.NRNATURUBR = EH.NRNATURUBR
  /*CP NOVO*/
  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
               FROM FPA_INCIDEVENTO IE
               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
               JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                      FROM FPA_GRPITEM 
                                     WHERE NRGRPINCIDE = 46) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
             ) CP ON CP.NREVENTOM = EM.NREVENTOM
                 AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
  /*IRRF NOVO*/
  LEFT JOIN (SELECT IE.NREVENTOM, TI.DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) CDESOCIAL
               FROM FPA_INCIDEVENTO IE
               JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
               JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
              WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                      FROM FPA_GRPITEM 
                                     WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
              GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT
             ) IRRF ON IRRF.NREVENTOM = EM.NREVENTOM
                   AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||CF.NRTIPOMOVIMENT||',') > 0
 WHERE VM.NRORG = :P_NRORG
   AND VM.NRVINCULOM = :P_NRVINCULOM
   AND IT.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
   AND IT.VREVENTOFOLHA > 0
   AND ((IT.IDEVENDEMONCALC = 'N' AND EH.IDEVENTODEMONST = 'N') OR (EH.IDEVENTODEMONST = 'S')) /*SE NÃO DEMONSTRATIVO NO CADASTRO E DEMONSTRATIVO NA FOLHA NÃO ENVIA*/
   AND (CP.CDESOCIAL NOT IN (23, 24, 61) OR CP.CDESOCIAL IS NULL) /*{codIncCP} em S-1010 seja igual a [23, 24, 61]*/
   AND (IRRF.CDESOCIAL NOT IN (31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83) OR IRRF.CDESOCIAL IS NULL) /*{codIncIRRF} em S-1010 seja igual a [31, 32, 33, 34, 35, 51, 52, 53, 54, 55, 81, 82, 83]*/
   /*AND {codIncCp} em S-1010 seja igual a [25, 26, 51] se {codCateg} pertencer a um dos grupos 'contribuinte individual' ou 'bolsistas' da Tabela 01 (Categoria de Trabalhadores).*/
 ORDER BY IT.NREVENTOM
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRVINCULOM" => $nrvinculom,
            "P_NRCALCULOFOLHA" => $nrcalculofolha,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS1200ideADC($params) {
        try {
            $dados = $this->getDadosIdeADC($params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['NRCALCULOFOLHA'], $params['CDCATEGTRAB']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosIdeADC($nrorg, $nrpessoa, $nrinscricaoparc, $nrcalculofolha, $cdcategtrab) {
        $sql = <<<SQL
/*getDadosS1200ideADC*/
SELECT '' AS dtAcConv,
       'F' AS tpAcConv,
       'Rescisão Complementar' AS dsc,
       'N' AS remunSuc,
       /*idePeriodo getDadosS1200idePeriodo*/
       VM.NRORG, VM.NRVINCULOM, VM.NRPESSOA, PN.NRINSCRICAOPARC, IT.NRCALCULOFOLHA NRCALCULOFOLHA, :P_CDCATEGTRAB CDCATEGTRAB
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Pagamentos*/
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NREVENTOM = 3050
  /*Estabelecimento/Lotacao*/
  JOIN ESTRUTURAM EM ON EM.NRORG = VH.NRORG
                    AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN PARCNEGOCIO PN ON PN.NRORG = EM.NRORG
                     AND PN.NRPARCNEGOCIO = EM.NRPARCNEGOCIO
  /*Categoria Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND VM.DTRESCISAOVINC < :P_DTMESCOMPETENC
   AND VM.NRPESSOA = :P_NRCHAVE
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND IT.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
   AND CE.CDESOCIAL = :P_CDCATEGTRAB
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRCHAVE" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_NRCALCULOFOLHA" => $nrcalculofolha,
            "P_CDCATEGTRAB" => $cdcategtrab,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS1200idePeriodo($params) {
        try {
            $dados = $this->getDadosIdePeriodo($params['NRORG'], $params['NRVINCULOM'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['NRCALCULOFOLHA'], $params['CDCATEGTRAB']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosIdePeriodo($nrorg, $nrvinculom, $nrpessoa, $nrinscricaoparc, $nrcalculofolha, $cdcategtrab) {
        $sql = <<<SQL
/*getDadosS1200idePeriodo*/
SELECT TO_CHAR(VM.DTRESCISAOVINC, 'YYYY-MM') AS perRef,
       0 AS infoPerApur,
       SUM(CASE WHEN (VM.DTRESCISAOVINC < :P_DTMESCOMPETENC) THEN 1 ELSE 0 END) AS infoPerAnt,
       /*ideEstabLot getDadosS1200ideEstabLot*/
       :P_NRORG NRORG, :P_NRPESSOA NRPESSOA, :P_NRINSCRICAOPARC NRINSCRICAOPARC, :P_NRCALCULOFOLHA NRCALCULOFOLHA, :P_CDCATEGTRAB CDCATEGTRAB
  FROM GPE_VINCULOM VM
 WHERE VM.NRORG = :P_NRORG
   AND VM.NRVINCULOM = :P_NRVINCULOM
 GROUP BY TO_CHAR(VM.DTRESCISAOVINC, 'YYYY-MM'), :P_NRORG, :P_NRPESSOA, :P_NRINSCRICAOPARC, :P_NRCALCULOFOLHA, :P_CDCATEGTRAB
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRVINCULOM" => $nrvinculom,
            "P_NRPESSOA" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_NRCALCULOFOLHA" => $nrcalculofolha,
            "P_CDCATEGTRAB" => $cdcategtrab,
        );
        return $this->connection->fetchAll($sql, $params);
    }

    public function getDadosS1200remunPerAnt($params) {
        try {
            $dados = $this->getDadosRemunPerAnt($params['NRORG'], $params['NRPESSOA'], $params['NRINSCRICAOPARC'], $params['NRCALCULOFOLHA'], $params['CDCATEGTRAB']);
            return $dados;
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function getDadosRemunPerAnt($nrorg, $nrpessoa, $nrinscricaoparc, $nrcalculofolha, $cdcategtrab) {
        $sql = <<<SQL
/*getDadosS1200remunPerAnt*/
SELECT DISTINCT
       CASE WHEN CE.CDESOCIAL IN ('101','102','103','104','105','106','111','301','302','303','305','306','307','308','309') THEN NVL(VH.CDMATRICULAESOCIAL, VM.NRVINCULOM) ELSE NULL END AS matricula,
       NULL AS indSimples,
       CASE
         WHEN CE.CDESOCIAL IN ('101','102','103','104','105','106','111','201','202','301','302','303','305','306','307','308','309','731','734','738')
         THEN DECODE(AN.CDESOCIALNOCIVO,NULL,1,AN.CDESOCIALNOCIVO)
         ELSE NULL
       END AS grauExp,
       VM.NRORG, VM.NRVINCULOM, IT.NRCALCULOFOLHA
  FROM GPE_VINCULOM VM
  JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                      AND VH.NRVINCULOM = VM.NRVINCULOM
                      AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH H1
                                                WHERE H1.NRVINCULOM = VH.NRVINCULOM
                                                  AND H1.NRORG = VH.NRORG
                                                  AND H1.DTMESCOMPETENC >= ADD_MONTHS(TRUNC(TO_DATE(:P_DTMESCOMPETENC),'YEAR'),-12)
                                                  AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  /*Pagamentos*/
  JOIN FPA_ITECALCFOLHA IT ON IT.NRORG = VH.NRORG
                          AND IT.NRVINCULOM = VH.NRVINCULOM
                          AND IT.NRCALCULOFOLHA = :P_NRCALCULOFOLHA
                          AND IT.NREVENTOM = 3050
  /*Estabelecimento/Lotacao*/
  JOIN ESTRUTURAM EM ON EM.NRORG = VH.NRORG
                    AND EM.NRESTRUTURAM = VH.NRESTRUTLEGAL
  LEFT JOIN ESTRUTURAH EH ON EH.NRORG = EM.NRORG
                    AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
                    AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH H1
                                              WHERE H1.NRESTRUTURAM = EH.NRESTRUTURAM
                                                AND H1.NRORG = EH.NRORG
                                                AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
  JOIN PARCNEGOCIO PN ON PN.NRORG = EM.NRORG
                     AND PN.NRPARCNEGOCIO = EM.NRPARCNEGOCIO
  /*Categoria Trabalhador*/
  JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
  JOIN GPE_CATEGTRABESOC CE ON CE.NRCATEGESOC = VE.NRCATEGESOC
  /*Grau de Exposição de Agente Nocivo*/
  LEFT JOIN GPE_AGENTENOCIVO AN ON AN.NRAGENTENOCIVO = VH.NRAGENTENOCIVO
 WHERE VM.NRORG = :P_NRORG
   AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
   AND VM.DTRESCISAOVINC < :P_DTMESCOMPETENC
   AND VM.NRPESSOA = :P_NRCHAVE
   AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_NRINSCRICAOPARC,1,8)
   AND CE.CDESOCIAL = :P_CDCATEGTRAB
SQL;
        $params = array(
            "P_NRORG" => $nrorg,
            "P_DTMESCOMPETENC" => $this->hcmParameters->getDtCompetencia(),
            "P_NRCHAVE" => $nrpessoa,
            "P_NRINSCRICAOPARC" => $nrinscricaoparc,
            "P_NRCALCULOFOLHA" => $nrcalculofolha,
            "P_CDCATEGTRAB" => $cdcategtrab,
        );
        return $this->connection->fetchAll($sql, $params);
    }
    
}