<?php
/** 
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 08/08/2016
 * Time: 14:51
 */

namespace HCM\TRE\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\DateUtil;
use HCM\Util\HCMParameters;

class CustomizavelTreRepository {

    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function getRelatCustomizavel($idexibirconteudocurso, $where_placeholder, $buttonFloatingSearch)
    {
        $colunasConteudoCurso = $joinConteudoCurso = '';

        if($idexibirconteudocurso == 'S'){
            $colunasConteudoCurso = ' 
                CNTCUR.NMCONTEUDOCURSO,
                CNTCUR.QTHORCONTEUDOCURSO,
                CNTCUR.DSOBSCONTEUDOCURSO, 
            ';
            
            $joinConteudoCurso = '
                LEFT JOIN GPE_CONTEUDOCURSO CNTCUR 
                        ON (
                            CNTCUR.NRCURSO = CUR.NRCURSO 
                            AND CNTCUR.NRORG = CUR.NRORG 
                        ) 
            ';                    
                                

        }else{
            $colunasConteudoCurso = ' 
                NULL AS NMCONTEUDOCURSO,
                NULL AS QTHORCONTEUDOCURSO,
                NULL AS DSOBSCONTEUDOCURSO, 
            ';
        } 

        $sql = "

SELECT * FROM (
    SELECT
        TRE.NRORG,
        TRE.NRTREINAMENTO,
        TRE.NRCURSO,
        TRE.NRPERFACESAPROV,
        TRE.NRPERFACESEXEC,
        TRE.NRMETODOTRE,
        TRE.NRPARCNEGAPROV,
        TRE.NRPARCINSTRUTOR,
        TRE.NRTPCUSTOTRE,
        TRE.NMTREINAMENTO,
        TRE.IDTREINAMENTOINT,
        TRE.DTAPROVTREINAMENTO,
        TRE.DSOBSAPROVTREINAMENTO,
        TRE.DTINIPLANEJADOTRE,
        TRE.DTFIMPLANEJADOTRE,
        TRE.DTINIREALIZADOTRE,
        TRE.DTFIMREALIZADOTRE,
        TRE.DTVALIDADETREINAMENTO,
        TRE.VRCUSTOPLATREINAMENTO,
        TRE.VRCUSTOREALTREINAMENTO,
        TRE.IDSTATUSTREINAMENTO,
        TRE.IDEFICACIATREINAMENTO,
        TRE.DSOBSEFICACIATRE,
        TRE.NRCRITERIORESUL,
        TRE.DSOBSTREINAMENTO,
        TRE.DTINCLUSAO,
        PART.NRPARTICIPATRE,
        PART.VRNOTAPARTICIPATRE,
        PART.VRPERFREQUENCIATRE,
        PART.NRPARCNEGOCIO,
        DSP.NRDESPESATRE,
        DSP.NRTPCUSTOTRE AS NRTPCUSTODS,
        DSP.CDDESPADMFAT,
        DSP.VRPLANEJADODESPTRE,
        DSP.VRREALIZADODESPTRE,
        LCL.NRLOCALTREINAMENTO,
        LCL.NRESTRUTURAM,
        LCL.DTINILOCALTREINAMETNO,
        LCL.DTFINLOCALTREINAMENTO,
        MTR.NRPRODUTOTRE,
        MTR.CDPRODUTO,
        MTR.DTINIPRODUTOTRE,
        MTR.DTFINPRODUTOTRE,
        MTR.QTPRODUTOTRE,
        AVLT.NRAVALTREINAMENTO,
        AVLT.NRAVALIACAO,
        CUR.NRTIPOCURSO,
        CUR.NRCONFIGCURSO,
        CUR.NMCURSO,
        CUR.DSPROGRAMA,
        CUR.CDESCOLARIDADE,
        CUR.QTCARGAHORARIA,
        CUR.DSOBJETIVOCURSO,
        CUR.DSOBSERVACAOCURSO,
        ESCO.DSESCOLARIDADE,
        PFCUR.NMPERFILCURSO,
        ITPFC.NRITPERFILCURSO,
        ITPFC.NRPERFILCURSO,
        ITPFC.QTPERIODOMESES,
        CFGCUR.NMCONFIGCURSO,
        CFGCUR.NRPERFACESAPROV AS PERFACESAPROVCFG,
        CFGCUR.NRPERFACESEXEC AS PERFACESEXECCFG,
        TPCUSTRE.NMTPCUSTOTRE AS NMTPCUSTO,
        CRESULT.NMCRITERIORESUL,
        TPRESU.CDTIPORESU,
        TPRESU.NMTIPORESU,
        TPCUR.NMTIPOCURSO,
        $colunasConteudoCurso
        PFCUR_EST.NRPERFILCURSOESTRUT,
        PFCUR_EST.NRESTRUTURAM AS PFNRESTRUTURAM,
        PFCUR_EST.IDPERFILCURSOESTRUT,
        ESTRMPF.NMESTRUTURAM AS PFNMESTRUTURAM,
        OCUPAH.NMOCUPACAOH,
        PFCUR_CUPA.NRPERFILCURSOOCUPA,
        PFCUR_CUPA.NROCUPACAOM,
        PFCUR_CUPA.IDPERFILTREOCUPA,
        PFCUR_VINC.NRPERFILCURSOVINCULO,
        PFCUR_VINC.NRVINCULOM,
        PFCUR_VINC.IDPERFILCURSOVINCULO,
        VINCM.NMVINCULOM,
        MTDTRE.NMMETODOTRE,
        AVLG.NMAVALIACAO,
        PRPART.NMPRINCIPALPARC,
        TPCUSTRE.NMTPCUSTOTRE AS NMTPCUSTOPDT,
        ESTRM.NMESTRUTURAM,
        PDT.NMPRODUTO,
        DSPPMF.DSDESPADMFAT,
        PNEG_APROV.NMPRINCIPALPARC AS NMPARCNEGAPROV,
        PFA_EXEC.NMPERFILACESSO AS NMPERFACESEXEC,
        PNEG_EXEC.NMPRINCIPALPARC AS NMPARCINSTRUTOR,
        PFA_APROV.NMPERFILACESSO AS NMPERFACESAPROV,
        VINCH.NRESTRUTLEGAL AS NRESTRUTURAM_LEGAL,
        VINCH.NRESTRUTGEREN AS NRESTRUTURAM_GERENCIAL,
        VINCH.NRESTRUTSIND AS NRESTRUTURAM_SINDICAL,
        ESTRLEGAL.NMESTRUTURAM AS NMESTRUTURAM_LEGAL,
        ESTRGEREN.NMESTRUTURAM AS NMESTRUTURAM_GERENCIAL,
        ESTRSIND.NMESTRUTURAM AS NMESTRUTURAM_SINDICAL 
    FROM
        GPE_TREINAMENTO TRE 
    
    LEFT JOIN GPE_CURSO CUR 
            ON  TRE.NRCURSO = CUR.NRCURSO 
            AND TRE.NRORG = CUR.NRORG 
            
    LEFT JOIN ESCOLARIDADE ESCO 
            ON  CUR.CDESCOLARIDADE = ESCO.CDESCOLARIDADE 
            AND (TRE.NRORG = ESCO.NRORG OR ESCO.NRORG = :P_NRORG_PADRAO) 
             
    LEFT JOIN GPE_METODO_TRE MTDTRE 
            ON  TRE.NRMETODOTRE = MTDTRE.NRMETODOTRE 
            AND TRE.NRORG = MTDTRE.NRORG 
        
    LEFT JOIN GPE_PARTICIPATRE PART 
            ON  TRE.NRTREINAMENTO = PART.NRTREINAMENTO 
            AND TRE.NRORG = PART.NRORG 
            
    LEFT JOIN TIPORESU TPRESU 
            ON TPRESU.CDTIPORESU = PART.CDTIPORESU 
            AND TPRESU.NRORG=TRE.NRORG 
    
    LEFT JOIN GPE_DESPESATRE DSP 
            ON  TRE.NRTREINAMENTO = DSP.NRTREINAMENTO 
            AND TRE.NRORG = DSP.NRORG 
            
    LEFT JOIN GPE_LOCALTREINAMENTO LCL 
            ON  TRE.NRTREINAMENTO = LCL.NRTREINAMENTO 
            AND TRE.NRORG = LCL.NRORG 
            
    LEFT JOIN GPE_RESERVAPRODTRE MTR 
            ON  TRE.NRTREINAMENTO = MTR.NRTREINAMENTO 
            AND TRE.NRORG = MTR.NRORG 
            
    LEFT JOIN GPE_AVALTREINAMENTO AVLT 
            ON  TRE.NRTREINAMENTO = AVLT.NRTREINAMENTO 
            AND TRE.NRORG = AVLT.NRORG 
            
    LEFT JOIN PERFILACESSO PFA_APROV 
            ON  TRE.NRPERFACESAPROV = PFA_APROV.NRPERFILACESSO 
            AND TRE.NRORG = PFA_APROV.NRORG 
            
    LEFT JOIN PARCNEGOCIO PNEG_APROV 
            ON  TRE.NRPARCNEGAPROV = PNEG_APROV.NRPARCNEGOCIO 
            AND TRE.NRORG = PNEG_APROV.NRORG 
            
    LEFT JOIN PERFILACESSO PFA_EXEC 
            ON 
                TRE.NRPERFACESEXEC = PFA_EXEC.NRPERFILACESSO 
            AND TRE.NRORG = PFA_EXEC.NRORG 
             
    LEFT JOIN PARCNEGOCIO PNEG_EXEC 
            ON  TRE.NRPARCINSTRUTOR = PNEG_EXEC.NRPARCNEGOCIO 
            AND TRE.NRORG = PNEG_EXEC.NRORG 
            
    LEFT JOIN GPE_TPCUSTOTRE TPCUSTRE 
            ON  TRE.NRTPCUSTOTRE = TPCUSTRE.NRTPCUSTOTRE 
            AND TRE.NRORG = TPCUSTRE.NRORG 
            
    LEFT JOIN CRITERIORESULT CRESULT 
            ON  TRE.NRCRITERIORESUL = CRESULT.NRCRITERIORESUL 
            AND TRE.NRORG = CRESULT.NRORG 
            
    LEFT JOIN GPE_TIPOCURSO TPCUR 
            ON  CUR.NRTIPOCURSO = TPCUR.NRTIPOCURSO 
            AND CUR.NRORG = TPCUR.NRORG 
            
    LEFT JOIN GPE_CONFIGCURSO CFGCUR 
            ON  CUR.NRCONFIGCURSO = CFGCUR.NRCONFIGCURSO 
            AND CUR.NRORG = CFGCUR.NRORG 
            
    LEFT JOIN PARCNEGOCIO PRPART 
            ON  PART.NRPARCNEGOCIO = PRPART.NRPARCNEGOCIO 
            AND PART.NRORG = PRPART.NRORG 
             
    LEFT JOIN GPE_TPCUSTOTRE CSTTRE 
            ON  DSP.NRTPCUSTOTRE = CSTTRE.NRTPCUSTOTRE 
            AND DSP.NRORG = CSTTRE.NRORG 
            
    LEFT JOIN ESTRUTURAM ESTRM 
            ON  LCL.NRESTRUTURAM = ESTRM.NRESTRUTURAM 
            AND LCL.NRORG = ESTRM.NRORG 
            
    LEFT JOIN PRODUTO PDT 
            ON  MTR.CDPRODUTO = PDT.CDPRODUTO 
            AND MTR.NRORG = PDT.NRORG 
            
    LEFT JOIN DESPADMFATUR DSPPMF 
            ON  DSP.CDDESPADMFAT = DSPPMF.CDDESPADMFAT 
            AND DSP.NRORG = DSPPMF.NRORG 
            
    LEFT JOIN AVALIACAOGERAL AVLG 
            ON  AVLT.NRAVALIACAO = AVLG.NRAVALIACAO 
            AND AVLT.NRORG = AVLG.NRORG 
            
    LEFT JOIN GPE_ITPERFILCURSO ITPFC 
            ON  ITPFC.NRCURSO = CUR.NRCURSO 
            AND ITPFC.NRORG = CUR.NRORG 
            
    LEFT JOIN GPE_PERFILCURSO PFCUR 
            ON  PFCUR.NRPERFILCURSO = ITPFC.NRPERFILCURSO 
            AND PFCUR.NRORG = ITPFC.NRORG 
            
    LEFT JOIN PERFACESSPARC PFCUR_APROV 
            ON  PFCUR_APROV.NRPERFACESSPARC = CFGCUR.NRPERFACESAPROV 
            AND PFCUR_APROV.NRORG = CFGCUR.NRORG 
            
    LEFT JOIN PERFACESSPARC PFCUR_EXEC 
            ON  PFCUR_EXEC.NRPERFACESSPARC = CFGCUR.NRPERFACESEXEC 
            AND PFCUR_EXEC.NRORG = CFGCUR.NRORG 
            
    
    $joinConteudoCurso
    
    LEFT JOIN GPE_PERFILCURSOEST PFCUR_EST 
            ON  PFCUR_EST.NRPERFILCURSO = PFCUR.NRPERFILCURSO 
            AND PFCUR_EST.NRORG = PFCUR.NRORG 
            
    LEFT JOIN GPE_PERFILCURSOCUPA PFCUR_CUPA 
            ON  PFCUR_CUPA.NRPERFILCURSO = PFCUR.NRPERFILCURSO 
            AND PFCUR_CUPA.NRORG = PFCUR.NRORG 
            
    LEFT JOIN GPE_PERFILCURSOVINC PFCUR_VINC 
            ON  PFCUR_VINC.NRPERFILCURSO = PFCUR.NRPERFILCURSO 
            AND PFCUR_VINC.NRORG = PFCUR.NRORG 
             
    LEFT JOIN ESTRUTURAM ESTRMPF 
            ON PFCUR_EST.NRESTRUTURAM = ESTRMPF.NRESTRUTURAM 
               AND PFCUR_EST.NRORG = ESTRMPF.NRORG 
            
    LEFT JOIN GPE_OCUPACAOH OCUPAH 
            ON PFCUR_CUPA.NROCUPACAOM = OCUPAH.NROCUPACAOM 
            AND PFCUR_CUPA.NRORG = OCUPAH.NRORG 
            AND OCUPAH.DTMESCOMPETENC = ( SELECT MAX(OH.DTMESCOMPETENC) 
                                          FROM GPE_OCUPACAOH OH 
                                          WHERE OH.NRORG = OCUPAH.NRORG 
                                          AND OH.NROCUPACAOM = OCUPAH.NROCUPACAOM 
                                          AND OH.DTMESCOMPETENC <= :P_DTMESCOMPETENC 
                                        )                            
    LEFT JOIN GPE_VINCULOM VINCM 
            ON  PFCUR_VINC.NRVINCULOM = VINCM.NRVINCULOM 
            AND PFCUR_VINC.NRORG = VINCM.NRORG 
            
    JOIN GPE_PESSOA PESS 
            ON PESS.NRPARCNEGOCIO = PART.NRPARCNEGOCIO 
            AND PESS.NRORG = PART.NRORG 
             
    JOIN GPE_VINCULOM VINCPESS 
            ON PESS.NRPESSOA = VINCPESS.NRPESSOA 
            AND PESS.NRORG = VINCPESS.NRORG 
            AND ( VINCPESS.DTRESCISAOVINC IS NULL OR VINCPESS.DTRESCISAOVINC >=:P_DTMESCOMPETENC ) 
             
    JOIN
        (
            SELECT
                A.NRORG,
                A.NRVINCULOM,
                A.NRESTRUTLEGAL,
                A.NRESTRUTGEREN,
                A.NRESTRUTSIND 
            FROM
                GPE_VINCULOH A 
            WHERE
                DTMESCOMPETENC = (
                    SELECT
                        MAX(HH.DTMESCOMPETENC) 
                    FROM
                        GPE_VINCULOH HH 
                    WHERE
                        HH.NRORG = A.NRORG 
                        AND HH.NRVINCULOM = A.NRVINCULOM 
                        AND HH.DTMESCOMPETENC <= :P_DTMESCOMPETENC 
                ) 
            ) VINCH 
                ON (
                    VINCPESS.NRVINCULOM = VINCH.NRVINCULOM 
                    AND VINCPESS.NRORG = VINCH.NRORG 
                ) 
        JOIN ESTRUTURAM ESTRLEGAL 
                ON VINCH.NRESTRUTLEGAL = ESTRLEGAL.NRESTRUTURAM 
                AND VINCH.NRORG = ESTRLEGAL.NRORG 
                 
        JOIN ESTRUTURAM ESTRGEREN 
                ON VINCH.NRESTRUTGEREN = ESTRGEREN.NRESTRUTURAM 
                AND VINCH.NRORG = ESTRGEREN.NRORG 
                 
        JOIN ESTRUTURAM ESTRSIND 
                ON VINCH.NRESTRUTSIND = ESTRSIND.NRESTRUTURAM 
                AND VINCH.NRORG = ESTRSIND.NRORG 
                 
        WHERE
            (TRE.NRORG = :P_NRORG OR TRE.NRORG = :P_NRORG_PADRAO) 
        
        ORDER BY
            TRE.NRTREINAMENTO
     )
 WHERE $where_placeholder $buttonFloatingSearch";
        $params = [
                    "P_DTMESCOMPETENC"     => $this->hcmParameters->getDtCompetencia(),
                    "P_NRORG"              => $this->hcmParameters->getNrorgTrabalho(),
                    "P_NRORG_PADRAO"       => $this->hcmParameters->getNrorgPadrao(),                    
                  ];

        return $this->connection->fetchAll($sql, $params);
    }    
    
} 