-- ============================================================
-- Table: GPE_AGENTENOCIVO
-- ============================================================
create table GPE_AGENTENOCIVO
(
    NRAGENTENOCIVO NUMBER not null,
    CDAGENTENOCIVO VARCHAR2(10) null,
    DSAGENTENOCIVO VARCHAR2(250) null,
    VRPERCENTUAL FLOAT null,
    CDESOCIALNOCIVO VARCHAR2(10) null,
    NRORG NUMBER not null,
    IDATIVO VARCHAR2(1) default 'S' not null,
    DTINCLUSAO DATE not null,
    DTULTATU DATE null ,
    NRORGINCLUSAO NUMBER(22) default 1 null ,
    CDOPERINCLUSAO VARCHAR2(12) default '1' null ,
    NRORGULTATU NUMBER(22) default 1 null ,
    CDOPERULTATU VARCHAR2(12) default '1' null ,
    constraint GPE_AGENTENOCIVO_PK primary key (NRAGENTENOCIVO)
)
/

ALTER TABLE GPE_VINCULOH ADD NRAGENTENOCIVO NUMBER NULL
/

alter table GPE_VINCULOH
    add constraint FK_GPE_VINCULOH_NOCIVO foreign key (NRAGENTENOCIVO)
        references GPE_AGENTENOCIVO (NRAGENTENOCIVO)
/

-- ============================================================
-- Inserts
-- ============================================================
INSERT INTO GPE_AGENTENOCIVO
    (NRAGENTENOCIVO, CDAGENTENOCIVO, DSAGENTENOCIVO, VRPERCENTUAL, CDESOCIALNOCIVO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
VALUES
    (1, NULL, 'Sem exposição a agente nocivo - Trabalhador nunca esteve exposto', NULL, NULL, 0, 'S', SYSDATE, SYSDATE, 1, '1', 1, '1')
/
INSERT INTO GPE_AGENTENOCIVO
    (NRAGENTENOCIVO, CDAGENTENOCIVO, DSAGENTENOCIVO, VRPERCENTUAL, CDESOCIALNOCIVO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
VALUES
    (2, '01', 'Não exposição a agente nocivo - Trabalhador já esteve exposto', NULL, '1', 0, 'S', SYSDATE, SYSDATE, 1, '1', 1, '1')
/
INSERT INTO GPE_AGENTENOCIVO
    (NRAGENTENOCIVO, CDAGENTENOCIVO, DSAGENTENOCIVO, VRPERCENTUAL, CDESOCIALNOCIVO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
VALUES
    (3, '02', 'Exposição a agente nocivo (aposentadoria especial aos 15 anos de trabalho)', 12, '2', 0, 'S', SYSDATE, SYSDATE, 1, '1', 1, '1')
/
INSERT INTO GPE_AGENTENOCIVO
    (NRAGENTENOCIVO, CDAGENTENOCIVO, DSAGENTENOCIVO, VRPERCENTUAL, CDESOCIALNOCIVO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
VALUES
    (4, '03', 'Exposição a agente nocivo (aposentadoria especial aos 20 anos de trabalho)', 9, '3', 0, 'S', SYSDATE, SYSDATE, 1, '1', 1, '1')
/
INSERT INTO GPE_AGENTENOCIVO
    (NRAGENTENOCIVO, CDAGENTENOCIVO, DSAGENTENOCIVO, VRPERCENTUAL, CDESOCIALNOCIVO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
VALUES
    (5, '04', 'Exposição a agente nocivo (aposentadoria especial aos 25 anos de trabalho)', 6, '4', 0, 'S', SYSDATE, SYSDATE, 1, '1', 1, '1')
/
INSERT INTO GPE_AGENTENOCIVO
    (NRAGENTENOCIVO, CDAGENTENOCIVO, DSAGENTENOCIVO, VRPERCENTUAL, CDESOCIALNOCIVO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
VALUES
    (6, '05', 'Mais de um vínculo empregatício (ou fonte pagadora) - Não exposição a agente nocivo', NULL, NULL, 0, 'S', SYSDATE, SYSDATE, 1, '1', 1, '1')
/
INSERT INTO GPE_AGENTENOCIVO
    (NRAGENTENOCIVO, CDAGENTENOCIVO, DSAGENTENOCIVO, VRPERCENTUAL, CDESOCIALNOCIVO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
VALUES
    (7, '06', 'Mais de um vínculo empregatício (ou fonte pagadora) - Exposição a agente nocivo (aposentadoria especial aos 15 anos de trabalho)', 12, '2', 0, 'S', SYSDATE, SYSDATE, 1, '1', 1, '1')
/
INSERT INTO GPE_AGENTENOCIVO
    (NRAGENTENOCIVO, CDAGENTENOCIVO, DSAGENTENOCIVO, VRPERCENTUAL, CDESOCIALNOCIVO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
VALUES
    (8, '07', 'Mais de um vínculo empregatício (ou fonte pagadora) - Exposição a agente nocivo (aposentadoria especial aos 20 anos de trabalho)', 9, '3', 0, 'S', SYSDATE, SYSDATE, 1, '1', 1, '1')
/
INSERT INTO GPE_AGENTENOCIVO
    (NRAGENTENOCIVO, CDAGENTENOCIVO, DSAGENTENOCIVO, VRPERCENTUAL, CDESOCIALNOCIVO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
VALUES
    (9, '08', 'Mais de um vínculo empregatício (ou fonte pagadora) - Exposição a agente nocivo (aposentadoria especial aos 25 anos de trabalho)', 6, '4', 0, 'S', SYSDATE, SYSDATE, 1, '1', 1, '1')
/